# -*- coding: utf-8 -*-


def migrate(cr, version):
    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code,
            'if not record.user_id and task_config.user_id:',
            'if not record.user_ids and task_config.user_ids:')
        WHERE id = 3050;""")
    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code,
            'record.write({''user_id'': task_config.user_id.id})',
            'record.write({''user_ids'': [(6,0, task_config.user_ids.ids)]})')
        WHERE id = 3050;""")

    cr.execute("""UPDATE ir_act_server
        SET code = replace(code, '''user_id'': 802942', '''user_ids'': [(6, 0, [802942])]')
        WHERE id = 3336;""")


    cr.execute("""UPDATE ir_act_server
        SET code = '
if not record.user_ids:
  raise Warning(''Please assign the template to the new employee getting on board'')


login = record.user_ids[:1].login
new_parent = record.copy({
        ''name'': record.name.replace(''TEMPLATE'', login),
        ''user_ids'': record.user_ids.ids,
        ''reviewer_id'': record.reviewer_id.id,
})
for sub in record.child_ids:
  sub.copy(default={
      ''parent_id'': new_parent.id,
      ''name'': sub.name.replace(''TEMPLATE'', login),
      ''user_ids'': record.user_ids.ids,
      ''reviewer_id'': record.reviewer_id.id,
      ''stage_id'': sub.stage_id.id,
  })

record.write({''user_ids'': False, ''reviewer_id'': False})

action = {
    ''type'': ''ir.actions.act_window'',
    ''view_mode'': ''form,kanban,tree,pivot'',
    ''res_model'': ''project.task'',
    ''res_id'': new_parent.id,
}'
        WHERE ID = 3581;""")

    cr.execute("""UPDATE ir_act_server
        SET code = '
company_prefix_mapping = {
   "Odoo S.A." : "[QSBE]",
   "Odoo Middle East DMCC" : "[QSDMCC]",
}
project_template = env.ref(''custo_tfr.template_qs_project'')
default = {
    ''name'': "%s %s" % (company_prefix_mapping.get(record.project_id.company_id.name, "[QSBE]"), record.name),
    ''user_id'': record.user_ids[:1].id,
    ''partner_id'': record.partner_id.id,
}
existing_project = env[''project.project''].search([(''name'', ''='', default[''name''])], limit=1)
if not existing_project:
    new_project = project_template.with_context(tracking_disable=True).copy(default=default)
    new_tasks = env[''project.task''].with_context(tracking_disable=True).search([(''project_id'', ''='', new_project.id)])
    new_tasks.write({
        ''user_ids'': [(6, 0, record.user_ids.ids)],
        ''partner_id'': record.partner_id.id,
        ''sale_line_id'': record.sudo().sale_line_id.id,
        ''parent_id'': record.id,
    })
    existing_project = new_project

action = {
    ''name'': default[''name''],
    ''type'': ''ir.actions.act_window'',
    ''view_mode'': ''kanban,tree,form,pivot'',
    ''res_model'': ''project.task'',
    ''context'': {
        ''search_default_project_id'': existing_project.id,
        ''default_project_id'': existing_project.id,
        ''search_default_display_project_id'': existing_project.id,
    },
}'
        WHERE id = 3646;""")

    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code, '''user_id'': False', '''user_ids'': False')
        WHERE id = 4397;""")
    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code, '[(4, upgrade_parents[0].user_id.id)]', '[(4, uid) for uid in upgrade_parents[0].user_ids.ids]')
        WHERE id = 4397;""")

    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code, 'rec.user_id', 'rec.user_ids')
        WHERE id = 4397;""")
    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code,
            'vals[''user_id''] = upgrade_parents[0].reviewer_id.id if prefix == ''BE'' else upgrade_parents[0].user_id.id',
            'vals[''user_ids''] = [(4, upgrade_parents[0].reviewer_id.id)] if prefix == ''BE'' else [(4, upgrade_parents[0].user_id.id)]'
        )
        WHERE id = 4397;""")

    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code, 'user_id', 'user_ids')
        WHERE id = 2022;""")
    cr.execute("""UPDATE ir_act_server
        SET code = REPLACE(code, 'default_user_id', 'default_user_ids')
        WHERE id = 3339;""")

    cr.execute(
        """
        UPDATE mail_template
        SET partner_to = '{{ '',''.join([str(x.id) for x in object.message_partner_ids if x.id not in object.mapped(''user_ids.partner_id'').ids]) }}'
        WHERE partner_to = '<%for x in object.message_follower_ids if x.id != object.user_id.partner_id.id%>{{ x.id }}<% if not loop.last %>,<% endif %><% endfor %>'
        """
    )

    cr.execute(
        """
        UPDATE mail_template
        SET partner_to = '{{ '',''.join(str(x) for x in object.message_partner_ids.ids) }}'
        WHERE id in (7130, 17350)
        """
    )

    cr.execute(
        """
        UPDATE mail_template
           SET email_from = '"{{ object.user_id.name.replace(''"'', "") if (object.user_id.name and object.user_id.name != ''Administrator'') else ''Odoo S.A.'' }}" <{{ object.user_id.email if (object.user_id.email and object.user_id.email != ''admin@odoo.com'') else ''noreply@odoo.com'' }}>'
         WHERE email_from = '"{{ object.user_id.name.replace(''"'', "") | safe  if (object.user_id.name and object.user_id.name != ''Administrator'') else ''Odoo S.A.'' }}" <{{ object.user_id.email if (object.user_id.email and object.user_id.email != ''admin@odoo.com'') else ''noreply@odoo.com'' }}>';
        """
    )

    cr.execute(
        """
        UPDATE mail_template
           SET email_to = '{($object.email or '''')}'
         WHERE email_to = '{($object.email or '''')|safe}';
        """
    )
